natlog (3.00.01)

  * Ready for libbobcat6

  * Added 'c++std' defining the c++ standard to use for
    compilation. Compilation commands also use -Werror

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Mon, 12 Sep 2022 08:36:37 +0200

natlog (3.00.00)

  * With mode 'conntrack' natlog writes 1 to 
    /proc/sys/net/netfilter/nf_conntrack_acct unless `no-bytes' was specified.
  * --verbose does not imply --stdout anymore.
  * conntrack supports protocol subselections (e.g., tcp:udp).
  * added option --no-dst suppressing destination entries in the log-files.
  * added option --rotate to force log file rotation.
  * added option --rotate-data to force log-data file rotation.

  * added class ProducerSignals as common baseclass for ConntrackProducer and
    DevicesProducer providing the Producer class and the signals required for
    --terminate.
  * All class-specific icmconf files are now soft-links to the base
    directory's icmconf.lib file.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Tue, 07 Jun 2022 12:59:20 +0200

natlog (2.04.02)

  * Added missing option entries to the etc/natlog.conf file
  * Included options S and terminate in the manpage's list of options that
    cannot be specified in the natlog.conf file.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 15 Apr 2022 21:09:32 +0200

natlog (2.04.01)

  * Changed the std version c++2a to c++20.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 21 Oct 2021 12:00:05 +0200

natlog (2.04.00)

  * Added option --no-via to suppress 'via' entries in the log files.
  * Added option --no-bytes to suppress the sent/received counts in the log
    files. 
  * Fixed several flaws in the default configuration file
  * Updated the man-page; added information about how to use Natlog if
    source-natting is not used.
  * Repaired flaw in icmake/findall: it now checks for 'backtick' returning a
    single, empty element.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Mon, 06 Sep 2021 20:15:17 +0200

natlog (2.03.00)

  * Fixed erroneously thrown 'bool' value in ipbase/destroy.cc when observing
    a DESTROY action of an unknown record.
  * Fixed missing sent/receive counts in mode conntrack
  * Fixed handling stripping in 'build'
  * Added main's call-tree to oxref's output
  * Added cross reference listing (natlog.xref)
  * Added icmconf files for internal use to natlog's directories

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Tue, 07 Jan 2020 20:50:34 +0100

natlog (2.02.00)

  * Requires bobcat >= 5.00.00

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Wed, 24 Apr 2019 12:15:01 +0200

natlog (2.01.01)

  * Migrated from Github to Gitlab

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Mon, 25 Jun 2018 11:44:12 +0200

natlog (2.01.00)

  * Simplified ConnectionsConsumer, added classes IPbase, TCP, UDP, and ICMP.

  * Redefined the RecordMap key handling, now using 64-bit keys. This should
    solve the incorrect handling of TCP connections observed with version
    2.00.00.

  * Commas instead of colons are used to separate IP-addresses from port
    numbers with TCP and UDP connections.

  * Using detached Pcap threads, to avoid long waiting times caused by
    pcap_loop's waiting for one additional packet after calling
    pcap_breakloop.

  * Repaired flaws in the byte-counting procedures

  * The Storage now contains pointers to Records. Once retrieved they are 
    handled by unique_ptrs, guaranteeing their eventual destructions.

  * Using C++-17 attributes ([[maybe_unused]]) where applicable.

  * The file documentation/simplified.def relates types used by objdump(1) to
    types used in natlog's source files. E.g., objdump reports
    std::__cxx11::basic_string<char, std::char_traits<char>,
    std::allocator<char> > while std::string is used in natlog's source
    files. This information can be used by other programs, like oxref(1) to
    improve the readability of their output.

  * Added option -S to be used as natlog's first argument in systemd's
    natlog.service file's ExecStart= specifications.

  * Added option --debug writing information about memory consumption to the
    log file

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 22 Mar 2018 16:38:24 +0100

natlog (2.00.00)

  * Added mode tcpdump processing captured tcpdump files

  * Modes tcpdump, conntrack and device (formerly known as mode pcap) log
    files show numbers of bytes that were sent and received. 

  * To use byte-accounting in mode conntrack the following command must have
    been issued (after starting iptables):

        /bin/echo "1" > /proc/sys/net/netfilter/nf_conntrack_acct

  * Added option --contrack-device, by default set to /proc/net/nf_conntrack.
    Older systems may still use /proc/net/ip_conntrack, which may be selected
    using this option.

  * Added option --ip-header-size, correcting for the IP header sizes which
    are added by conntrack to its logs.

  * Added option --log, replacing the former --no-syslog option. --log can be
    used to specify a log-file instead of using syslog facilities.

  * Added option --log-data, specifying a path to a log file to contain a
    table that can be used by statistical software.

  * Added option --log-rotate, specifying time-interval between log-file
    rotations and number of log-files to rotate.

  * Option --protocol can be used to process tcp, udp, and/or icmp protocols
    for all three modes. To process all three protocols '--protocol all' can
    be specified. With mode conntrack only a single protocol or 'all' can be
    used. 
 
  * Added option --terminate terminating a running natlog daemon process.

  * Added option --ttl for udp/icmp and/or tcp connections

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 08 Feb 2018 19:36:39 +0100

natlog (1.03.00)

  * Fixed bug when setting syslog-facility in options/setSyslogFacility:
    instead of using the assignment operator (=) to set the facility
    the comparison operator (==) was written... :-(

  * The --verbose option can be abbreviated to -V. When specified twice, the
    actual configuration parameters are shown. When specified more often,
    natlog ends after showing the configuration parameters.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 26 Jan 2017 12:27:40 +0100

natlog (1.02.03)

  * Adapted  natlog's build scripts to icmake >= 8.00.03

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 11 Dec 2015 17:17:43 +0100

natlog (1.02.02)

  * Kevin Brodsky observed that the installation scripts used 'chdir' rather
    than 'cd'. Fixed in this release.

  * Kevin Brodsky also observed that the combined size of all precompiled 
    headers might exceed some disks capacities. The option -P was added to the
    ./build script to prevent the use of precompiled headers.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Mon, 05 Oct 2015 21:06:54 +0200

natlog (1.02.01)

  * Standardized the (de)installation procedures. See INSTALL for details.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 04 Oct 2015 16:09:21 +0200

natlog (1.02.00) 

  * Conntrack(8) has two modes: when -p <proto> is specified conntrack shows
    connections of protocol <proto>. When -p is not specified connections of
    all protocols are shown. When multiple -p options are specified only the
    last specified protocol is selected. Conntrack commands generated by
    natlog before 1.02.00 erroneously specified multiple -p options. This was
    fixed in version 1.02.00.

 * The man-page shows `:syslogtag, isequal, "NATLOG:" stop' rather than
    (the now deprecated) `:syslogtag, isequal, "NATLOG:"   ~'.

 * The previously discontinued option conntrack-path is no longer recognized.

 * The --protocol option can also be specified as -P.

  * Added the file 'required' to the source distribution summarizing the
    required software for building natlog.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Mon, 23 Feb 2015 11:05:53 +0100

natlog (1.01.0) 

  * Added configuration option `conntrack-command'. With the `conntrack'
    command the icmp, udp and tcp layer four protocols are monitored. By
    default natlog's `conntrack' command monitors the tcp protocol.

  * Added configuration option `conntrack-restart, to specify how often
    conntrack may be restarted if its process prematurely ends.

  * The configuration option `conntrack-path' is discontinued, and
    `conntrack-command' should be used instead. See the man-page for details.

  * Added configuration option `protocol', to specify which layer four
    protocols to monitor with the `conntrack' command.

  * The default pid file path is set to `/run/natlog.pid'.

  * Replaced FBB::Errno calls by FBB::Exception

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Mon, 10 Feb 2014 20:21:27 +0100

natlog (1.00.2) 

  * Added a missing #include <sstream> to the showseconds.ih header, required
    by g++ 8.4.2. 

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 01 Dec 2013 18:15:46 +0100

natlog (1.00.1) 

  * Natlog's version bumped to 1.00.1, after 1 year of active use.

  * Removed the class Signal from natlog's classes as it's available in
    Bobcat. 

  * Explicitly including previously implicitly included  bobcat/errno

  * Cleanup of icmconf file

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sat, 08 Jun 2013 10:57:34 +0200

natlog (0.91.3) 
  
  * Natlog returns 0 for options --help and --version

  * Catching Errno exceptions is replaced by catching std::exception
    exceptions 

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 25 Jan 2013 08:58:07 +0100

natlog (0.91.2) 
  
  * Added build-depends file and INSTALL files.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Wed, 07 Nov 2012 12:03:53 +0100

natlog (0.91.1) 

  * build script recognizes CXX, CXXFLAGS, LDFLAGS environment variables

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 15 Jul 2012 14:40:11 +0200

natlog (0.91.0) 

  * Normal end of program (e.g., the starting daemon or ending
    natfork/childprocess) now returns 0, otherwise 1

  * Checking whether conntrack runs is implemented by inspecting the access
    rights for /proc/net/ip_conntrack

  * Reorganized message handling: all messages generated by the daemon are
    sent to the syslog daemon, unless --no-syslog was specified

  * General code cleanup

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 21 Jun 2012 13:45:11 +0200

natlog (0.90.0) 

  * Updated sourceforge's `excluded' file.

  * Added the --pid-file option defining the location of a file holding 
    the daemon's PID. By default the pid-file is /var/run/natlog.pid. 

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sat, 16 Jun 2012 12:03:01 +0200

natlog (0.80.0) 

  * Added auto-detection of devices without Ethernet packet headers

  * Natlog's pcap mode now writes syslog messages

  * Added option --stdout (-s) writing syslog-equivalent messages to the
    standard ouput

  * General code cleanup and reorganization

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 15 Jun 2012 17:01:08 +0200

natlog (0.30.0) 

  * Initial implementation of 'natlog in out', performing direct packet
    capturing on the `in' and `out' devices.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 14 Jun 2012 14:37:42 +0200

natlog (0.20.0)

  * NATLOG writes incomplete connections to syslog when terminated by a
    SIGTERM signal.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Mon, 11 Jun 2012 16:42:40 +0200

natlog (0.10.0)

  * NATLOG now hosted at sourceforge (http://natlog.sourceforge.net/).

  * Added maintenance files to handle uploads to sourceforge

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sat, 09 Jun 2012 16:39:34 +0200

natlog (0.03.0)

  * Syslog message and man-page cleanup

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 07 Jun 2012 17:20:04 +0200

natlog (0.02.0)

  * Processed elements are now removed from `record' in conntrack/run.cc

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 07 Jun 2012 14:10:19 +0200

natlog (0.01.0)

  * Project Start.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Tue, 05 Jun 2012 22:17:08 +0200
